#include <stdio.h>
#include <string.h>
#include "machine.h"
#include "getargs.h"
#include "libpperf.h"
#include "job_control.h"

/* This is the main file for pperf.  Not much 
 *     here since swicthing to libpperf.
 *     
 *     M. Patrick Goda  13 Nov 1997
 *     pgoda@lanl.gov
 */

void 
main ( int argc, char *argv[] )
{ 
  int event0, event1;
  int cpl0, cpl1;
  int verb;
  float t_step;
  char *runfile[128];
  int err;

  getargs(argc,argv,runfile,&event0,&event1,&cpl0,&cpl1,&verb,&t_step);
    
  err = start_counters(event0,cpl0,event1,cpl1);

  if (err == DEV_MSR_NOT_OPENED)
    {
      fprintf(stderr,
	      "pperf: Cannot continue without msr.o module loaded.\n");
      exit(0);
    }

  printf("pperf: (start_counters) Counters started.\n");

  if (t_step != 0.0)
    start_print_counters(t_step,SHORT);

  run_command(runfile);

  if (t_step != 0.0)
    stop_print_counters();

  print_counters(verb);

}
