C***********************************************************************
C***  simple test program for PCL

      PROGRAM PCL_test
C*** declarations
      IMPLICIT NONE
      INCLUDE 'pclh.f'
      INTEGER N
      PARAMETER(N=32)
      INTEGER counter_list(1), event, flags, res
      INTEGER*8 result
      INTEGER PCLquery, PCLstart, PCLstop
      EXTERNAL PCLquery, PCLstart, PCLstop
      EXTERNAL matmul
      REAL*8 a(N,N), b(N,N), c(N,N)

C*** count for user mode
      flags = PCL_MODE_USER
C***  loop over all defined event types
      DO event=0,PCL_MAX_EVENT-1

         counter_list(1) = event
C***     check if event is available
         res = PCLquery(counter_list, 1, flags)
         IF(res .EQ. PCL_SUCCESS) THEN

C***        start counting
            IF(PCLstart(counter_list, 1, flags) .NE. PCL_SUCCESS) THEN
               WRITE(*,*) 'problem with starting event ',event
            ENDIF

C***        do some work
            CALL matmul(a,b,c,n)

C***        stop counting
            IF(PCLstop(result, 1) .NE. PCL_SUCCESS) THEN
               WRITE(*,*) 'problem with stopping event ',event
            ENDIF

C***        write results
            WRITE(*,1000) event, DBLE(result)

         ELSE
C***        event not supported
            WRITE(*,1001) event, res
         ENDIF
      ENDDO

 1000 FORMAT('event ',I2,': ',F18.0)
 1001 FORMAT('event ',I2,': not supported (',I2,')')

      STOP
      END

C***********************************************************************

      SUBROUTINE matmul(a,b,c,n)
      IMPLICIT NONE
      INTEGER N,i,j,k
      REAL*8 a(N,N), b(N,N), c(N,N)

      DO i=1,n
         DO j=1,n
            a(i,j) = 0.0
            DO k=1,n
               a(i,j) = a(i,j) + b(i,k) * c(k,j)
            ENDDO
         ENDDO
      ENDDO

      RETURN
      END

C***********************************************************************
